<?php
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin'))
{
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentCashBill extends vmPSPlugin 
{

    public static $_this = false;

    function __construct(& $subject, $config) 
	{
		parent::__construct($subject, $config);
		
		$this->_loggable = true;
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$this->tableFields = array_keys($this->getTableSQLFields());
		$varsToPush = array(
			'cashbill_id' => array('', 'string'),
			'cashbill_key' => array('', 'string'),
			'auto_redirect' => array(1, 'int'),
			'powiadomienia' => array(1, 'int'),
			'tax_id' => array(0, 'int'),
			'url_pozytywny' => array('', 'string'),
			'url_online' => array('', 'string'),
			'status_pending' => array('', 'string'),
			'status_success' => array('', 'string'),
			'status_canceled' => array('', 'string'),
			'auto_potwierdz' => array(1, 'int'),
	    );
		
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
		
	}
	
	
	
	function getTableSQLFields()
	{
	    $SQLfields = array
	    (
	        'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id' => 'int(11) UNSIGNED',
            'order_number' => 'varchar(32)',
            'virtuemart_paymentmethod_id' => 'mediumint(1)',
	        'payment_name' => 'varchar(255)',
	        'tax_id' => 'int(11)',
	        'status'=>'varchar(255)'
	    );
	    return $SQLfields;
	}
	
	protected function getVmPluginCreateTableSQL()
	{
	    return $this->createTableSQL('Platnosci CashBill');
	}
	
	
	function plgVmPotwierdzenieCashBill($cart, $order, $auto_redirect = false, $form_method = "POST")
	{
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Inna metoda została wybrana, nie rób nic.
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}

		if (!class_exists('VirtueMartModelOrders')){
			require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		
		$this->getPaymentCurrency($method);
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		
		$currencyCode = $paymentCurrency->ensureUsingCurrencyCode($method->payment_currency);
		$amount = number_format($order['details']['BT']->order_total, 2 , '.', '');
		
		$orderDetails = $order['details']['BT'];
		
		$hidden = array();
		
		$hidden = array(
		    'service'=>$method->cashbill_id,
			'amount'=>$amount,
			'currency'=> $currencyCode,
			'desc'=>'Zamówienie nr : '.$orderDetails->order_number,
			'lang' => "",
		    'userdata'=>$orderDetails->order_number,
		    'ref'=>'VirtueMart',
		    'forname'=>$orderDetails->first_name,
		    'surname'=>$orderDetails->last_name,
			'email'=>$orderDetails->email,
			'tel' => "",
			'street'=>$orderDetails->address_1,
			'street_n1' => "",
			'street_n2' => "",
		    'city'=>$orderDetails->city,
		    'postcode'=>$orderDetails->zip,
		    'country'=>ShopFunctions::getCountryByID ($orderDetails->virtuemart_country_id, 'country_3_code'),
		);
 
		$hidden['sign'] = md5(implode('|',$hidden).'|'.$method->cashbill_key);
		
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['order_number'] = $orderDetails->order_number;
		$dbValues['tax_id'] = $method->tax_id;
		$dbValues['status'] = 'Rozpoczete';
		$dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
		$this->storePSPluginInternalData($dbValues);
		
		$html = '
		<div style="text-align: center; width: 100%; ">
		<form action="https://pay.cashbill.pl/form/pay.php" method="'.$form_method.'" class="form" name="platnosc_cashbill" id="platnosc_cashbill">';
		

		foreach( $hidden as $key => $value )
		{
			$html .= '<input type="hidden" name="'.$key.'" value="'.$value.'">
			    ';
		}
			

			$html .= '<input name="submit_send" value="Zapłać z CashBill" type="submit"  style="width: 200px; height: 45px;" /> ';
			
		
		$html .= '	</form>		
		
		<script language=”JavaScript” type=”text/javascript”>
			document.forms[\'platnosci_cashbill\'].js.value=1;
		</script>
		
		<p style="text-align: center; width: 100%; ">'.$method->checkout_text.'</p>
		</div>
		';

		if ($method->auto_redirect && $auto_redirect) {
		    $html .= '
			<script type="text/javascript">
				document.getElementById("platnosc_cashbill").submit();
			</script>';
		}
		
		
		return $html;
	}
	
	function plgVmConfirmedOrder($cart, $order)
	{

		if (!($html = $this->plgVmPotwierdzenieCashBill($cart, $order, true))) {
			return false; 
		}
		
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) 
		{
			return null;
		}
		$nazwa_platnosci = $this->renderPluginName($method);
		vRequest::setVar('html', $html);
		return $this->processConfirmedOrderPaymentResponse(1, $cart, $order, $html, $nazwa_platnosci, $method->status_pending);
	}

	public function checkSignature($data,$key,$sign){
		if(md5($data['service'].$data['orderid'].$data['amount'].$data['userdata'].$data['status'].$key) === $sign){
				return true;
		}

		if(md5($data['service'].'|'.$data['orderid'].'|'.$data['amount'].'|'.$data['userdata'].'|'.$data['status'].'|'.$key) === $sign){
			return true;
		}

		return false;
	}
	
	function plgVmOnPaymentResponseReceived(&$html) 
	{
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; 
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		
		if(isset($_POST['service']))
		{
		    if($this->checkSignature($_POST,$method->cashbill_key,$_POST['sign']))
		    {
		        if(!class_exists('VirtueMartModelOrders'))
		            require (JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		        
		        $virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($_POST['userdata']);
		        if(strtoupper($_POST['status']) == 'OK')
		        {
		        $message = 'Wpłata w kwocie '.$_POST['amount'].' PLN została zaksięgowana dla zamówienia o ID : '.$_POST['userdata'].' ID CashBill : '.$_POST['orderid'];
		        $this->paymentNewStatus($virtuemart_order_id,$method->status_success,$message,$method->powiadomienia);
		            
		        }
		        if(strtoupper($_POST['status']) == 'ERR')
		        {
		        $message = 'Wpłata nie została zaksięgowana przez CashBill. ID CashBill : '.$_POST['orderid'];
		        $this->paymentNewStatus($virtuemart_order_id,$method->status_canceled,$message,$method->powiadomienia);
		        }
		      
		        
		       
		        
		    echo 'OK';    
		    exit();    
		    }
		    
		    echo 'BLAD SYGNATURY';
		    exit();
		}else
		{
            JFactory::getApplication()->enqueueMessage('Dziękujemy za dokonanie płatności za pośrednictwem płatności CashBill');
            return true;
		}    

		
	}

	public function paymentNewStatus($virtuemart_order_id, $status, $comment, $notification )
	{

	    if(!class_exists('VirtueMartModelOrders'))
	        require (JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
	    $modelOrder = new VirtueMartModelOrders();
	    $order['order_status'] = $status;
	    $order['virtuemart_order_id'] = $virtuemart_order_id;
	    $order['customer_notified'] = $notification;
	    $order['comments'] = $comment;
	    $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
	    return true;
	
	}

    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id) 
	{
		if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
			return null;
		}

		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			vmWarn(500, $q . " " . $db->getErrorMsg());
			return '';
		}
		
		$this->getPaymentCurrency($paymentTable);

		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('Payment', $paymentTable->payment_name);	
		$html .= $this->getHtmlRowBE('Order Number', $paymentTable->order_number);
		$html .= $this->getHtmlRowBE('Order ID', $paymentTable->virtuemart_order_id);
		$html .= '</table>' . "\n";
		return $html;
    }
	

	
     function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		return 0;
    }


    protected function checkConditions($cart, $method, $cart_prices) {
		return true;
    }

    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

	return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
	return $this->OnSelectCheck($cart);
    }


    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
	return $this->displayListFE($cart, $selected, $htmlIn);
    }


    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
	return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
	return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    protected function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	  $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	return $this->onShowOrderPrint($order_number, $method_id);
    }
    public function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        // nadpisujemy parametr , aby edycja nic mu nie robiła!
        $virtuemart_paymentmethod_id = $_GET['cid'][0];
        $url_pozytywny = 'url_pozytywny="' . JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $virtuemart_paymentmethod_id . '"|';
        $url_online = 'url_online="' . JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $virtuemart_paymentmethod_id . '"|';
        $data->payment_params .= $url_pozytywny;
        $data->payment_params .= $url_online;

        return $this->declarePluginParams('payment', $data);
    }

    public function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }
}